#!/usr/bin/env node
"use strict";

var _Deployator = _interopRequireWildcard(require("./Deployator"));

var _sshDeployRelease = _interopRequireDefault(require("ssh-deploy-release"));

var _yargs = _interopRequireDefault(require("yargs"));

var _initializeConfiguration = _interopRequireDefault(require("./initialize-configuration"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const argv = _yargs.default.command({
  command: 'list [--config]',
  desc: 'List available environments',
  handler: argv => {
    (0, _Deployator.listEnvironments)(argv);
  }
}).command({
  command: 'deploy [--config] [--environment] [--debug] [--synchronize]',
  desc: 'Deploy release to the remote server',
  handler: argv => {
    const deployator = new _Deployator.default(argv, _sshDeployRelease.default);
    deployator.deploy();
  }
}).command({
  command: 'remove [--config] [--environment] [--debug]',
  desc: 'Deploy release to the remote server',
  handler: argv => {
    const deployator = new _Deployator.default(argv, _sshDeployRelease.default);
    deployator.remove();
  }
}).command({
  command: 'rollback [--config] [--environment] [--debug]',
  desc: 'Rollback to the previous release',
  handler: argv => {
    const deployator = new _Deployator.default(argv, _sshDeployRelease.default);
    deployator.rollback();
  }
}).command({
  command: 'init [--config]',
  desc: 'Initialize configuration file',
  handler: argv => {
    (0, _initializeConfiguration.default)(argv.config);
  }
}).demandCommand().option('config', {
  alias: 'c',
  describe: 'path of configuration file'
}).option('environment', {
  alias: 'e',
  describe: 'environment name (example: review, preproduction)'
}).option('debug', {
  alias: 'd',
  describe: 'Enable debug mode',
  boolean: true
}).option('synchronize', {
  alias: 's',
  describe: 'Enable synchronize mode',
  boolean: true
}).help().showHelpOnFail().argv;